/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the ScPermission type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ScPermission{}

// ScPermission struct for ScPermission
type ScPermission struct {
	Id string `json:"id"`
	Name string `json:"name"`
	OrganizationId string `json:"organization_id"`
	MainRolloutId string `json:"main_rollout_id"`
	TermsContent string `json:"terms_content"`
	TermsContentHash string `json:"terms_content_hash"`
	Active bool `json:"active"`
	CreatedAt string `json:"created_at"`
	UpdatedAt string `json:"updated_at"`
	Acceptances []Acceptance `json:"acceptances,omitempty"`
}

// NewScPermission instantiates a new ScPermission object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewScPermission(id string, name string, organizationId string, mainRolloutId string, termsContent string, termsContentHash string, active bool, createdAt string, updatedAt string) *ScPermission {
	this := ScPermission{}
	this.Id = id
	this.Name = name
	this.OrganizationId = organizationId
	this.MainRolloutId = mainRolloutId
	this.TermsContent = termsContent
	this.TermsContentHash = termsContentHash
	this.Active = active
	this.CreatedAt = createdAt
	this.UpdatedAt = updatedAt
	return &this
}

// NewScPermissionWithDefaults instantiates a new ScPermission object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewScPermissionWithDefaults() *ScPermission {
	this := ScPermission{}
	return &this
}

// GetId returns the Id field value
func (o *ScPermission) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *ScPermission) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *ScPermission) SetId(v string) {
	o.Id = v
}

// GetName returns the Name field value
func (o *ScPermission) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *ScPermission) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *ScPermission) SetName(v string) {
	o.Name = v
}

// GetOrganizationId returns the OrganizationId field value
func (o *ScPermission) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *ScPermission) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *ScPermission) SetOrganizationId(v string) {
	o.OrganizationId = v
}

// GetMainRolloutId returns the MainRolloutId field value
func (o *ScPermission) GetMainRolloutId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.MainRolloutId
}

// GetMainRolloutIdOk returns a tuple with the MainRolloutId field value
// and a boolean to check if the value has been set.
func (o *ScPermission) GetMainRolloutIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.MainRolloutId, true
}

// SetMainRolloutId sets field value
func (o *ScPermission) SetMainRolloutId(v string) {
	o.MainRolloutId = v
}

// GetTermsContent returns the TermsContent field value
func (o *ScPermission) GetTermsContent() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TermsContent
}

// GetTermsContentOk returns a tuple with the TermsContent field value
// and a boolean to check if the value has been set.
func (o *ScPermission) GetTermsContentOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TermsContent, true
}

// SetTermsContent sets field value
func (o *ScPermission) SetTermsContent(v string) {
	o.TermsContent = v
}

// GetTermsContentHash returns the TermsContentHash field value
func (o *ScPermission) GetTermsContentHash() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TermsContentHash
}

// GetTermsContentHashOk returns a tuple with the TermsContentHash field value
// and a boolean to check if the value has been set.
func (o *ScPermission) GetTermsContentHashOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TermsContentHash, true
}

// SetTermsContentHash sets field value
func (o *ScPermission) SetTermsContentHash(v string) {
	o.TermsContentHash = v
}

// GetActive returns the Active field value
func (o *ScPermission) GetActive() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.Active
}

// GetActiveOk returns a tuple with the Active field value
// and a boolean to check if the value has been set.
func (o *ScPermission) GetActiveOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Active, true
}

// SetActive sets field value
func (o *ScPermission) SetActive(v bool) {
	o.Active = v
}

// GetCreatedAt returns the CreatedAt field value
func (o *ScPermission) GetCreatedAt() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *ScPermission) GetCreatedAtOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *ScPermission) SetCreatedAt(v string) {
	o.CreatedAt = v
}

// GetUpdatedAt returns the UpdatedAt field value
func (o *ScPermission) GetUpdatedAt() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value
// and a boolean to check if the value has been set.
func (o *ScPermission) GetUpdatedAtOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UpdatedAt, true
}

// SetUpdatedAt sets field value
func (o *ScPermission) SetUpdatedAt(v string) {
	o.UpdatedAt = v
}

// GetAcceptances returns the Acceptances field value if set, zero value otherwise.
func (o *ScPermission) GetAcceptances() []Acceptance {
	if o == nil || IsNil(o.Acceptances) {
		var ret []Acceptance
		return ret
	}
	return o.Acceptances
}

// GetAcceptancesOk returns a tuple with the Acceptances field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ScPermission) GetAcceptancesOk() ([]Acceptance, bool) {
	if o == nil || IsNil(o.Acceptances) {
		return nil, false
	}
	return o.Acceptances, true
}

// HasAcceptances returns a boolean if a field has been set.
func (o *ScPermission) HasAcceptances() bool {
	if o != nil && !IsNil(o.Acceptances) {
		return true
	}

	return false
}

// SetAcceptances gets a reference to the given []Acceptance and assigns it to the Acceptances field.
func (o *ScPermission) SetAcceptances(v []Acceptance) {
	o.Acceptances = v
}

func (o ScPermission) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ScPermission) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["name"] = o.Name
	toSerialize["organization_id"] = o.OrganizationId
	toSerialize["main_rollout_id"] = o.MainRolloutId
	toSerialize["terms_content"] = o.TermsContent
	toSerialize["terms_content_hash"] = o.TermsContentHash
	toSerialize["active"] = o.Active
	toSerialize["created_at"] = o.CreatedAt
	toSerialize["updated_at"] = o.UpdatedAt
	if !IsNil(o.Acceptances) {
		toSerialize["acceptances"] = o.Acceptances
	}
	return toSerialize, nil
}

type NullableScPermission struct {
	value *ScPermission
	isSet bool
}

func (v NullableScPermission) Get() *ScPermission {
	return v.value
}

func (v *NullableScPermission) Set(val *ScPermission) {
	v.value = val
	v.isSet = true
}

func (v NullableScPermission) IsSet() bool {
	return v.isSet
}

func (v *NullableScPermission) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableScPermission(val *ScPermission) *NullableScPermission {
	return &NullableScPermission{value: val, isSet: true}
}

func (v NullableScPermission) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableScPermission) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


